<template>
 <v-page :header-text="headerText">
    <br v-if="isSignedIn"/>
    <font-awesome-icon icon="check-circle" class="icon-success"/>
    <br/>
    <div class="text">Password changed</div>

    <div v-if="!isSignedIn">
      <input v-model="email" type="email" placeholder="Email" ref="emailInput" @input="onInput" @keyup.enter="onSignIn"/>
      <br/>
      <input
          v-model="pass"
          type="password"
          placeholder="Password"
          ref="passInput"
          @input="onInput"
          @keyup.enter="onSignIn"
      />
      <FormErrorMessage v-if="error">{{ error }}</FormErrorMessage>
      <br/>
      <v-button :in-progress="inProgress" @click="onSignIn">Sign in</v-button>
    </div>

    <div v-else>
      <v-button @click="onSignInFinished">{{ buttonSignInFinishedText }}</v-button>
    </div>

    <v-button-link to="/user-auth">back</v-button-link>
  </v-page>
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'

  import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
  import { library } from '@fortawesome/fontawesome-svg-core'
  import { faCheckCircle } from '@fortawesome/free-solid-svg-icons'

  import { animateError, FormErrorMessage, TokenManager, VButton, VButtonLink, VPage } from 'zeus-common'
  import { SignInError } from '@/common/sign-in/service'
  import { ButtonSignInFinished, header as headerText } from '@/config'

  const { mapState } = createNamespacedHelpers('signIn')

  library.add(faCheckCircle)

  export default {
    name: 'PasswordChangedPage',
    components: { FontAwesomeIcon, FormErrorMessage, VPage, VButton, VButtonLink },
    props: {
      email: String
    },
    data: () => ({
      headerText: headerText,
      pass: '',
      isSignedIn: TokenManager.getSignInToken() != null,
      buttonSignInFinishedText: ButtonSignInFinished.text
    }),
    computed: {
      ...mapState([ 'inProgress', 'error' ]),
    },
    beforeDestroy() {
      this.$store.commit('signIn/resetError')
    },
    watch: {
      error(error) { switch (error) {
        case SignInError.NoSuchEmail:
          animateError(this.$refs.emailInput)
          break
        case SignInError.IncorrectPassword:
          animateError(this.$refs.passInput)
          break
        case SignInError.EmailIsNotConfirmed:
          this.$store.commit('confirmationEmailSent/setCredentials', { email: this.email, pass: this.pass})
          this.$router.push('/confirmation-email-sent')
          break
        default: break
      }}
    },
    methods: {
      onSignIn() {
        this.onInput()
        let errorCounter = 0

        if (!this.email) {
          animateError(this.$refs.emailInput)
          errorCounter++
        }
        if (!this.pass) {
          animateError(this.$refs.passInput)
          errorCounter++
        }
        if (errorCounter === 0) {
          this.$store.dispatch('signIn/signIn', {
            email: this.email,
            pass: this.pass,
            onSuccess: ButtonSignInFinished.go
          })
        }
      },
      onInput() {
        if (this.error != null) {
          this.$store.commit('signIn/resetError')
        }
      },
      onSignInFinished() {
        ButtonSignInFinished.go()
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "~zeus-common/src/component/color";

  .icon-success {
    color: $color-success;
    font-size: 2.5em;
    margin-bottom: 0.5em;
  }
  .text {
    margin-bottom: 2em;
  }
</style>